#include <winsock2.h>
#include <stdlib.h>
#include <stdio.h>

#define BUFSIZE 4096

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(-1);
}

//  Լ  
void err_display(char *msg) 
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

//     Լ
int recvn(SOCKET s, char *buf, int len, int flags)
{
	int received;
	char *ptr = buf;
	int left = len;

	while(left > 0){
		received = recv(s, ptr, left, flags);
		if(received == SOCKET_ERROR) 
			return SOCKET_ERROR;
		else if(received == 0) 
			break;
		left -= received;
		ptr += received;
	}

	return (len - left);
}


class File_Server
{
private:
	int retval;				//   Ѥ.. 뷫  Լ ϰ Ȱ
	WSADATA wsa;			// 
	SOCKADDR_IN serveraddr;	//   ü
	SOCKET listen_sock;		//   
	SOCKET client_sock;		// ϴ Ŭ̾Ʈ 
	SOCKADDR_IN clientaddr;	// ϴ Ŭ̾Ʈ ü

	char buf[BUFSIZE];		// 
	int totalbytes;			//    ũ ޱ
	char filename[256];		//  ̸
	int currbytes;			// ̾ޱ⸦ Ҷ ʿ , ũⰡ .

	
	bool Client_Accept();				// Ŭ̾Ʈ ٽ ó Լ
	void Client_Disconnect();			//   ޾ ش Ŭ̾Ʈ ϴ Լ
	bool Client_Send_FilePosition();	//   ġ(=  ũ) 
	bool Client_Recv_Filesize();		// Ŭ̾ƮԷκ    ޴´.
	bool Check_File();					//  ̹ ִ ˻ϱ
	bool File_Download();				//   ޱ

public:
	File_Server(char *ip, int port);	// socket 𿡼 listen ܰ ϰó ܰ
	~File_Server();						// α׷   ۾
	void Server_Loop();					//  
};