#include "sender.h"

void File_Client::File_SendName()
{
	//  
	ZeroMemory(filename, 256);
	printf("  ̸ ԷϽÿ. : ");
	scanf("%s",filename);
	fp = fopen(filename, "rb");
	if(fp == NULL){
		perror(" б ");
		exit(1);
	}

	//  ̸ 	
	retval = send(sock, filename, 256, 0);
	if(retval == SOCKET_ERROR) err_quit("send()");
}

void File_Client::File_RecvSize()
{
	//   ġ(=  ũ) ޱ	
	retval = recvn(sock, (char *)&currbytes, sizeof(currbytes), 0);
	if(retval == SOCKET_ERROR) err_quit("recv()");
}

bool File_Client::File_SendSize()
{
	//  ũ 
	fseek(fp, 0, SEEK_END);
	totalbytes = ftell(fp);
	totalbytes -= currbytes;

	if(totalbytes == 0)
		return false;
	//   ũ 
	retval = send(sock, (char *)&totalbytes, sizeof(totalbytes), 0);
	if(retval == SOCKET_ERROR) err_quit("send()");	
	return true;
}

void File_Client::File_Upload()
{
	char buf[BUFSIZE];			// ѹ  
	int numread;
	int numtotal = 0;			// 

	//   
	fseek(fp, currbytes, SEEK_SET); //  ͸   ġ ̵
	while(1)
	{
		numread = fread(buf, 1, BUFSIZE, fp);		//  ۻ ŭ д´.
		if(numread > 0)
		{
			retval = send(sock, buf, numread, 0);	//    .
			if(retval == SOCKET_ERROR)
			{
				err_display("send()");
				break;
			}
			numtotal += numread;
			printf("."); //  Ȳ ǥ
		}
		else if(numread == 0 && numtotal == totalbytes)
		{
			printf("\n  Ϸ!: %d Ʈ\n", numtotal);
			break;
		}
		else
		{
			perror("  ");
			break;
		}
	}
	fclose(fp);
}

// connet  ϰó
File_Client::File_Client()
{
	//  ʱȭ
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		exit(1);

	// socket()
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET) err_quit("socket()");	

	char ip[20];
	int port;
	printf("Ϸ  IPּҸ ÿ : ");
	scanf("%s",ip);
	printf("Ϸ  Port ÿ : ");
	scanf("%d",&port);
	// connect()	
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port = htons(port);
	serveraddr.sin_addr.s_addr = inet_addr(ip);
	retval = connect(sock, (SOCKADDR *)&serveraddr, sizeof(serveraddr));
	if(retval == SOCKET_ERROR) err_quit("connect()");
}

File_Client::~File_Client()
{
	closesocket(sock);		// closesocket()
	WSACleanup();			//  
}

// ⺻ Ʈ
void File_Client::File_SendProc()
{
	File_SendName();
	File_RecvSize();
	if(!File_SendSize())
	{
		printf(" ̹  ö ֽϴ. \n");
		return ;
	}
	File_Upload();
}

int main()
{
	File_Client Client;
	Client.File_SendProc();
	return 0;
}