#include <winsock2.h>
#include <stdlib.h>
#include <stdio.h>

#define BUFSIZE 4096

//  Լ    
void err_quit(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	MessageBox(NULL, (LPCTSTR)lpMsgBuf, msg, MB_ICONERROR);
	LocalFree(lpMsgBuf);
	exit(-1);
}

//  Լ  
void err_display(char *msg)
{
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER|
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, WSAGetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);
	printf("[%s] %s", msg, (LPCTSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
}

//     Լ
int recvn(SOCKET s, char *buf, int len, int flags)
{
	int received;
	char *ptr = buf;
	int left = len;

	while(left > 0){
		received = recv(s, ptr, left, flags);
		if(received == SOCKET_ERROR) 
			return SOCKET_ERROR;
		else if(received == 0) 
			break;
		left -= received;
		ptr += received;
	}

	return (len - left);
}

class File_Client
{
private:
	int retval;					//  Ű ϰ ϴ 
	WSADATA wsa;				// 
	SOCKET sock;				// Ŭ̾Ʈ 
	SOCKADDR_IN serveraddr;		//  ü

	//   ۿ  
	char filename[256];			//  ̸
	int currbytes;				//   ũ
	int totalbytes;				//  ü ũ
	FILE *fp;					//  ü

	void File_SendName();		//   ٰ 뺸
	void File_RecvSize();		//   ִٸ,   ũⰡ , ƴϸ 0 
	bool File_SendSize();		//    ؼ  
	void File_Upload();			//  ε 

public:
	File_Client();	//  Ŭ̾Ʈ connect ۾ ó
	~File_Client();						// Ÿ  . 
	void File_SendProc();				//  κ
};
