#include "active_sender.h"

void Active_Sender::File_SendName()
{
	//  
	ZeroMemory(filename, 256);
	printf("  ̸ ԷϽÿ. : ");
	scanf("%s",filename);
	fp = fopen(filename, "rb");
	if(fp == NULL)
	{
		perror(" б ");
		exit(1);
	}
	_ftime(&start); //   ð 

	//  ̸ 	
	retval = send(sock, filename, 256, 0);
	if(retval == SOCKET_ERROR) err_quit("send()");
}

void Active_Sender::File_SendSize()
{
	//  ũ 
	fseek(fp, 0, SEEK_END);
	totalbytes = ftell(fp);

	//   ũ 
	retval = send(sock, (char *)&totalbytes, sizeof(totalbytes), 0);
	if(retval == SOCKET_ERROR) err_quit("send()");	
}

void Active_Sender::File_Upload()
{
	//   ۿ  
	char buf[BUFSIZE];					// ѹ  Ʈġ 
	int numread;						// ѹ д  ũ
	int numtotal = 0;					//   ũ
	int transfer_rate_old = 0;			// ٷ Ŷ  
	int transfer_rate_new = 0;			// ̹ Ŷ 鼭 Ǵ 
	int persent = 0;

	//   
	rewind(fp); //  ͸   ̵
	while(1)
	{
		numread = fread(buf, 1, BUFSIZE, fp);
		if(numread > 0)								//  о
		{
			retval = send(sock, buf, numread, 0);	//  
			if(retval == SOCKET_ERROR)
			{
				err_display("send()");
				break;
			}
			numtotal += numread;					//   ´.

			// ۷ Ѵ.
			transfer_rate_new = (int)(100 * numtotal / totalbytes);	//  ؾ int ÷ο찡 Ȼ.
			if(transfer_rate_new > transfer_rate_old)
				printf("۷ = %d%%\n", persent++);// ӽù..  ̾ޱ ҽ   ȸ.
			transfer_rate_old = transfer_rate_new;
		}
		else if(numread == 0 && numtotal == totalbytes)			// ̻  , ü  ũ, ݱ  ũⰡ ٸ
		{
			printf("  Ϸ!: %d Ʈ\n", numtotal);

			_ftime(&finish); //  Ϸ ð 
			//  ҿ ð  & ȭ 
			double elapsed_time = (finish.time * 1000 + finish.millitm)	- (start.time * 1000 + start.millitm);
			printf(" ҿ ð: %.2f seconds.\n", elapsed_time/1000);
			break;
		}
		else
		{
			perror("  ");
			break;
		}
	}
	fclose(fp);
}

Active_Sender::Active_Sender()
{
	//  ʱȭ
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		exit(1);

	// socket()
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock == INVALID_SOCKET) err_quit("socket()");	

	char ip[20];
	int port;
	printf("Ϸ  IPּҸ ÿ : ");
	scanf("%s",ip);
	printf("Ϸ  Port ÿ : ");
	scanf("%d",&port);

	// connect()	
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port = htons(port);
	serveraddr.sin_addr.s_addr = inet_addr(ip);
	retval = connect(sock, (SOCKADDR *)&serveraddr, sizeof(serveraddr));
	if(retval == SOCKET_ERROR) err_quit("connect()");

}
Active_Sender::~Active_Sender()
{
	closesocket(sock);		// closesocket()
	WSACleanup();			//  
}

void Active_Sender::Send_Proc()
{
	File_SendName();
	File_SendSize();
	File_Upload();
}

int main()
{
	Active_Sender sender;
	sender.Send_Proc();
	return 0;
}