#include "file_receiver.h"

bool File_Server::Client_Accept()			
{
	int addrlen;		// ǹ  Ѥ.. ܼ ּ   
	addrlen = sizeof(clientaddr);
	client_sock = accept(listen_sock, (SOCKADDR *)&clientaddr, &addrlen);
	if(client_sock == INVALID_SOCKET)
	{
		err_display("accept()");
		return false;
	}
	printf("\n  Ŭ̾Ʈ : IP ּ=%s, Ʈ ȣ=%d\n", 
		inet_ntoa(clientaddr.sin_addr), ntohs(clientaddr.sin_port));

	return true;
}

//   ޾ ش Ŭ̾Ʈ ϴ Լ
void File_Server::Client_Disconnect()
{
	// closesocket()
	closesocket(client_sock);
	printf(" ޱ : IP ּ=%s, Ʈ ȣ=%d\n", 
		inet_ntoa(clientaddr.sin_addr), ntohs(clientaddr.sin_port));
}

//   ġ(=  ũ) 
bool File_Server::Client_Send_FilePosition()
{
	//    ̹ ִ üũؼ,
	//   ¶, currbytes 0(ó) ƴ϶  ٰ   Ǿ
	// װ Ŭ̾Ʈ ְ ȴ.
	retval = send(client_sock, (char *)&currbytes, sizeof(currbytes), 0);
	if(retval == SOCKET_ERROR)
	{
		err_display("send()");
		closesocket(client_sock);
		return false;
	}		
	return true;
}

// Ŭ̾ƮԷκ    ޴´.
bool File_Server::Client_Recv_Filesize()
{		
	retval = recvn(client_sock, (char *)&totalbytes, sizeof(totalbytes), 0);
	if(retval == SOCKET_ERROR)
	{
		err_display("recv()");
		closesocket(client_sock);
		return false;
	}
	if(totalbytes)
		printf("->   ũ: %d\n", totalbytes);
	else
	{
		printf("̹   ޾ Ƿ Ŭ̾Ʈ û մϴ");
		closesocket(client_sock);		// Ŭ̾Ʈ  ݰ 
		return false;
	}
	return true;
}

//  ̹ ִ ˻ϱ
bool File_Server::Check_File()
{
	//  ̸ ޱ
	ZeroMemory(filename, 256);
	retval = recvn(client_sock, filename, 256, 0);
	if(retval == SOCKET_ERROR)
	{
		err_display("recv()");
		closesocket(client_sock);
		return false;
	}
	printf("Ŭ̾Ʈ   : %s\n", filename);

	currbytes = 0;					// 켱  ũ⸦ ʱȭϰ
	FILE *fp;
	if((fp = fopen(filename, "rb")) != NULL)	//  .
	{										//   ̹   ִٸ
		fseek(fp, 0, SEEK_END);				//     ġ ͸ ű
		currbytes = ftell(fp);				//  ġ Ѵ.. ̾ޱ⸦ ϱ ó
		fclose(fp);
	}
	return true;
}

//   ޱ
bool File_Server::File_Download()
{
	//  
	FILE *fp = fopen(filename, "ab");	// ̳ʸ  ߰ ϴ  .
	// ̷ ϸ ̾ޱⰡ  ʴ´.
	if(fp == NULL)
	{
		perror("  ");
		closesocket(client_sock);
		return false;;
	}

	int numtotal = 0;					//   Ʈ 			
	while(1)
	{
		retval = recvn(client_sock, buf, BUFSIZE, 0);
		//    .
		if(retval == SOCKET_ERROR)
		{
			err_display("recv()");
			break;
		}
		else if(retval == 0) 
			break;
		else
		{
			fwrite(buf, 1, retval, fp);		// recv  ŭ ٴ .
			if(ferror(fp))					// ٰ 
			{
				perror("  ");
				break;
			}
			numtotal += retval;				//  Ʈ   Ѵ.
		}
	}
	fclose(fp);

	//   	
	if(numtotal == totalbytes)				//  Ʈ, ޱ  Ʈ ٸ
		printf("  ٿε Ͽ!\n");
	else
		printf("  е(߰ Ŷ )\n");

	return true;
}

// socket 𿡼 listen ܰ ϰó ܰ
File_Server::File_Server(char *ip, int port)		// IPּҿ portȣ  Է ޴´.
{
	//  ʱȭ
	if(WSAStartup(MAKEWORD(2,2), &wsa) != 0)
		exit(1);

	// , TCP
	listen_sock = socket(AF_INET, SOCK_STREAM, 0);
	if(listen_sock == INVALID_SOCKET) err_quit("socket()");	

	// bind()		
	ZeroMemory(&serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_port = htons(port);
	serveraddr.sin_addr.s_addr = inet_addr(ip);
	retval = bind(listen_sock, (SOCKADDR *)&serveraddr, sizeof(serveraddr));
	if(retval == SOCKET_ERROR) err_quit("bind()");

	// listen()
	retval = listen(listen_sock, SOMAXCONN);
	if(retval == SOCKET_ERROR) err_quit("listen()");
}

// α׷   ۾
File_Server::~File_Server()
{
	closesocket(listen_sock);		// closesocket()
	WSACleanup();					//  
}

//α׷ 
void File_Server::Server_Loop()
{
	while(1)
	{
		if(!Client_Accept())		// accept ó, н  Ŭ̾Ʈ  ٽ listen · 
			continue;
		if(!Check_File())			//   ִ Ȯ,    listen ·..
			continue;
		if(!Client_Send_FilePosition())	//    ٸ, or  ȹ޾Ҵٸ,    ؼ Ŭ̾Ʈ 
			continue;
		if(!Client_Recv_Filesize())	//   ü ũ⸦ ޴´.
			continue;
		if(!File_Download())		// ٿε 
			continue;
		Client_Disconnect();		// ٿε Ϸ,  Ŭ̾Ʈ   ٽ listen ·...
	}
}

int main()
{
	File_Server process("127.0.0.1",9000);
	process.Server_Loop();
	return 0;
}